package Program::C;

use strict;
use vars qw/$VERSION @ISA @EXPORT/;

require Exporter;
require AutoLoader;
require Program;
require Program::Statement;

@ISA = qw(Exporter AutoLoader Program);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(

);
$VERSION = '0.01';

# Preloaded methods go here.

sub get_language{'C'}
sub has_slashslash{undef}
sub has_hash{1}

sub new {
    my $that = shift;
    my $class = ref($that) || $that;
    my $self = {
	Program_name => shift,
	First_statement => undef,
	Current_statement => undef,
	Text => undef,
	Quote => q/"((?:\\\\.|[^"])*)"|'((?:\\\\.|[^'])*)'/,
        BlockBrackets => '{',
        Brackets => '([',
        EndOfStmt => ';',
        Other => '\w+'
    };
    bless $self, $class;
    $self->{Language} = $self->get_language;
    $self->{Comment} = ($self->has_slashslash) ? '/\*(.*?)\*/|//(.*?)\n' :
        '/\*(.*?)\*/';
    $self->{PreProcessor} = ($self->has_hash) ? '#.*?\n' : undef;
    return $self;
}

sub is_end_of_stmt {
    my $self = shift;
    my $statement = $self->{Current_statement};
    return 1 if (ref($statement->get_down) or
		 $statement->{code} !~ /\) ?(?:[^;]* \S+ ?;)* ?[^;]* \S+ ?$/);
    return 0;
}

sub code_starts_block {
    my $self = shift;
    my $statement = $self->{Current_statement};
    return 1 if ($statement->{code} =~ /\b(?:do|else) ?$/ or
		 $statement->{code} =~ /\) ?(?:[^;]* \S+ ?; ?)*/ or
		 ($statement->{code} =~ /\bclass\b/ and
		  $self->get_language ne 'C'));
    return 0;
}

sub stmt_is_subr {
    my ($self, $statement) = @_;
    if (!(ref $statement->get_down) and
	$statement->get_code =~ /\) ?(?:[^;]* \S+ ?; ?)*/) {
	my ($subname) = ($statement->get_code =~ /(\S+) ?\(/);
	return $subname;
    }
    return undef;
}

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__

# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

Program - A program

=head1 SYNOPSIS

Program ...

=head1 DESCRIPTION

Program

=head1 BUGS

The documentation for this module is incomplete.

=head1 AUTHOR

James Yolkowski

=head1 SEE ALSO

perl(1).

=cut
